<?php
function get_nearby_locations( $lat, $lng, $distance ) {
	global $wpdb;

	$earth_radius = 3959;

	$sql = $wpdb->prepare( "
		SELECT DISTINCT
			p.ID,
			p.post_title,
			latitude.meta_value as locLat,
			longitude.meta_value as locLong,
			( %d * acos(
			cos( radians( %s ) )
			* cos( radians( latitude.meta_value ) )
			* cos( radians( longitude.meta_value ) - radians( %s ) )
			+ sin( radians( %s ) )
			* sin( radians( latitude.meta_value ) )
			) )
			AS distance
		FROM $wpdb->posts p
		INNER JOIN $wpdb->postmeta latitude ON p.ID = latitude.post_id
		INNER JOIN $wpdb->postmeta longitude ON p.ID = longitude.post_id
		WHERE 1 = 1
		AND p.post_type = 'locations'
		AND p.post_status = 'publish'
		AND latitude.meta_key = 'latitude'
		AND longitude.meta_key = 'longitude'
		HAVING distance < %s
		ORDER BY distance ASC",
		$earth_radius,
		$lat,
		$lng,
		$lat,
		$distance
	);

	$nearbyLocations = $wpdb->get_results( $sql );

	if ( $nearbyLocations ) {
		return $nearbyLocations;
	}
}
?>