<?php
/* Template Name: Location Search */

get_header();

$location_search = sanitize_text_field($_POST['location_search']);
$loc_search = urlencode($location_search);
$distance = $_POST['distance'];

$distance_select = array(
	5 => '5 miles',
	10 => '10 miles',
	50 => '50 miles',
	100 => '100 miles',
);

?>

<div class="container">
	<form action="" method="POST" id="location-search-form">
		<input type="text" name="location_search" value="<?php echo $location_search; ?>" placeholder="Enter postcode or city">
		<select name="distance">
			<?php
			foreach($distance_select as $distance_option => $key) {
				echo '<option value="'.$distance_option.'"'.($_POST['distance'] == $distance_option ? ' selected' : '').'>'.$key.'</option>';
			}
			?>
		</select>
		<input type="submit" value="Search">
	</form>
	<?php
	if(!empty($loc_search)) {
		
		// Query the Google Maps API to find the address, postcode or city
		$url = 'https://maps.googleapis.com/maps/api/geocode/json?address=' . $loc_search . '&key=AIzaSyDxasOdDrsgF9Bx5LUR0KVo6y_kTMf3X1w&components=country:GB';
		$json = json_decode(file_get_contents($url));
		
		// Return the longitude and latitude of this location
		$lat = $json->results[0]->geometry->location->lat;
		$lng = $json->results[0]->geometry->location->lng;

		// Perform the search using our search function
		$location_result = get_nearby_locations($lat, $lng, $distance);
		
		echo '<ul>';
		
		if(!empty($location_result)) {
		
			// Display the results
			foreach ($location_result as $result) {
				
				$loc_id = $result->ID;
				$location = $result->post_title;
				$distance = intval($result->distance);
				
				echo '<li><a href="'.get_permalink($loc_id).'">'.$location.' <i>('.$distance.' miles)</i></a></li>';
				
			}
		
		} else {
			
			// No results
			echo '<li>No results found</li>';
			
		}
		
		echo '</ul>';
		
	}
	?>
</div>
<?php
get_footer();
?>